/*
Название: BreakStory.jsx
Приложение для использования: Adobe InDesign CS2-CS4
Версия: 1.1
Язык реализации (Среда): JavaScript (ExtendScript Toolkit 2)
Операционные системы (Платформы): PC, Macintosh (Windows, Mac OS)
Условия распространения: Бесплатно; На Ваш риск
Назначение: Отделение фреймов от цепочки (Story)
Функциональные ограничения: Не работает с цепочками, содержащиеми Text Path
Техническая поддержка: Sergey-Anosov@yandex.ru
===================================================
Name: BreakStory.jsx
Application to use with: Adobe InDesign CS2-CS4
Version: 1.1
Program language (Environment): JavaScript (ExtendScript Toolkit 2)
Operating systems (Platforms): PC, Macintosh (Windows, Mac OS)
Distribution terms: Freeware; At your own risk
Destination: Separating selected text frames in story
Functional limitations: Can not process stories which are containing Text Path
Technical support: Sergey-Anosov@yandex.ru
*/
var AD; // активный документ
var the_sel = new Array(); // выделение в активном документе
var SCRIPT_TITLE = "BreakStory";
var SCRIPT_VERSION = "v.1.1";
var SEL_LEN; // кол-во объектов в выделении
var TF_SEL = new Array();	// массив выделенных текстовых фреймов
var SELECTED = new Array();	// массив выделен/невыделен
var TF = new Array(); // массив исходных текстовых фреймов
var TF_COPY = new Array(); // массив копий текстовых фреймов
var TF_ID = new Array(); // массив ID исходных текстовых фреймов
var TF_NUMBER = new Array(); // массив порядковых номеров текстовых фреймов в цепочке
var CURRENT_STORY; // выбранная цепочка
var STORY_LEN; // длина цепочки
var CONSEC; // выбранные фреймы последовательны/непоследовательны
var VAR; // вариант контекстного меню в диалоге
var CONNECT_AFTER; // соединять выбранные фреймы после отделения
var WHAT; // выбранный пункт меню в диалоге
var i_SEL; // номер выбранного фрейма (если выделен только 1)
var SELECTED_START = false; // выделен самый первый фрейм в цепочке
var SELECTED_END = false; // выделен самый последний фрейм в цепочке
var AD_layers_vis = new Array(); // видимость слоев
var AD_layers_lock = new Array(); // заблокированность слоев
var SAVE = false; // команда на сохранение документа
var NEED_OPEN_LAYERS = false; // требование на открытие слоев
var LAYERS_WERE_OPEN = false;// слои были открыты
var CAN_TALK = true;// возможность вывода сообщений
//
// основной модуль
SET_VERSION();
CHECK_SELECTION();
DIALOG();
OPERATION();
//
// ПОДПРОГРАММА проверки выделенных объектов
function CHECK_SELECTION(){
if(app.documents.length == 0 ) {
	alert("There are no open documents!");
	exit();
};
AD = app.activeDocument;
the_sel = AD.selection;
SEL_LEN = the_sel.length;
if(SEL_LEN == 0){
	alert("There are no selected objects!");
	exit();
};
// сохраняем настройки слоев
SAVE_LAYERS_SETTINGS();
//
var UNLOCK_TF = false;
var UNGROUP = "";
// очищаем массивы
TF_SEL = TF_SEL.slice(0, 0);
SELECTED = SELECTED.slice(0, 0);
TF = TF.slice(0, 0);
TF_NUMBER = TF_NUMBER.slice(0, 0);
//
// все ли выделенные объекты являются текстовыми фреймами
for(var i=0; i < SEL_LEN; i++){
	TF_SEL.push(the_sel[i]);
	if(TF_SEL[i].constructor.name != "TextFrame") {
		if(TF_SEL[i].constructor.name == "Group"){
			UNGROUP = "Probably Ungroup command or White arrow\n"+
				  "(Direct selection) tool is to be used!";
		};// if
		alert("Some of selected objects are not Text Frames!\n"+
		      "Current version ("+SCRIPT_VERSION+") can not process that :-(\n"+
		      UNGROUP);
		the_exit();
	};// if
	//
	// все ли выделенные текстовые фреймы принадлежат к одной цепочке (Story)
	CURRENT_STORY = TF_SEL[i].parentStory;
	for(j=0; j < TF_SEL.length; j++){
		if(CURRENT_STORY != TF_SEL[j].parentStory){
			alert("Not all of selected text frames\n"+
			      "belong to the same story!\n");
			the_exit();
		};// if
	};// for j
};// for i
// количество фреймов в цепочке
STORY_LEN = CURRENT_STORY.textFrames.length;
if(STORY_LEN == 1) {
	alert("There is only 1 (one) text frame in the story!");
	the_exit();
};// if
//
// нет ли TEXT PATH в цепочке
if( TEXT_PATH_IN_STORY( CURRENT_STORY ) ){
	alert("The story contents Text Path(s)!\n"+
		     "Current version ("+SCRIPT_VERSION+") can not process that :-(");
	the_exit();
};// if
//
// формируем данные для обработки
for(var i=0; i < STORY_LEN; i++){
	//
	// формирование массива выделен/невыделен
	TF[i] = CURRENT_STORY.textFrames[i]
	for(var j=0; j < SEL_LEN; j++){
		if(TF_SEL[j] == TF[i]){
			SELECTED[i] = true;
			break;
		};// if
		else SELECTED[i] = false;
	};// for j
};// for i
//
// все ли выделенные фреймы последовательны в цепочке (Story)
CONSEC = true;
var true_counter = 0;
if(SEL_LEN > 1){
	for(var i=0; i < STORY_LEN-1; i++){
		if(SELECTED[i] == true){
			true_counter++;
			if(true_counter == SEL_LEN) break;
			if(SELECTED[i+1] == false){
				CONSEC = false;
				break;
			};// if
			else continue;
		};// if
	};// for i
};// if
//
// формирование массива номеров фреймов в цепочке
var START_TF
var NEXT_TF
START_TF = TF[0].startTextFrame;
for(var i = 0; i < STORY_LEN; i++){ 
	if( START_TF == TF[i]) {
		TF_NUMBER[i] = 1;
		break;
	};// if
};// for i
for(var i = 0; i < STORY_LEN; i++){
	NEXT_TF = START_TF.nextTextFrame;
	for( var j = i; j < STORY_LEN+1; j++){
		if(NEXT_TF == TF[j]){
			TF_NUMBER[i] = j;
			break;
		};// if
		START_TF = NEXT_TF;
	};// for j
};// for i
//
// сортируем массивы для ТФ в порядке возрастания
// номера фрейма в цепочке (1 ... STORY_LEN)
var OVERFLOWS = false;
for(var i = 0; i < STORY_LEN; i++){
	if( TF[i].overflows ) OVERFLOWS = true;// заодно проверяем переполнение
	for(var j = i; j < STORY_LEN-1; j++){
		if(TF_NUMBER[j] > TF_NUMBER[j+1]) {
			var TF_TMP = TF[j+1];
			var SELECTED_TMP = SELECTED[j+1];
			var TF_NUMBER_TMP = TF_NUMBER[j+1];
			TF[j+1] = TF[j];
			SELECTED[j+1] = SELECTED[j];
			TF_NUMBER[j+1] = TF_NUMBER[j];
			TF[j] = TF_TMP;
			SELECTED[j] = SELECTED_TMP;
			TF_NUMBER[j] = TF_NUMBER_TMP;
		};// if
	};// for j
}; // for i
// формируем текст для вывода предупреждений
var WARNING_MSG = "Warning(s):"
// если некоторые фреймы на невидимых и/или заблокированных слоях
if( NEED_OPEN_LAYERS ) {
	 WARNING_MSG = WARNING_MSG + "\n\nSome of text frames in the story\nare on locked or invisible layers!";
};// if
// если есть переполнение фреймов
if( OVERFLOWS ) {
		WARNING_MSG = WARNING_MSG + "\n\nThere is text overflow in the story!";
};// if
//  если не все выделенные фреймы последовательны в цепочке
if( !CONSEC ){
		WARNING_MSG = WARNING_MSG +"\n\nSome of selected text frames\n"+
				"are not cosecutive in the story!";
};// if
// собственно вывод предупреждений
if( CAN_TALK ) {
	if( WARNING_MSG != "Warning(s):" ) alert(  WARNING_MSG );
};// if
//
// проверка выделен ли первый и/или последний фрейм в цепочке
for(var i = 0; i < SEL_LEN; i++){
	if(TF_SEL[i] == TF[0].startTextFrame) SELECTED_START = true;
	if(TF_SEL[i] == TF[0].endTextFrame) SELECTED_END = true;
}// for i
return;
}// end CHECK_SELECTION
//
// ******** ПОДПРОГРАММА Создания копий фреймов цепочки
//	    и очисткии удаления  "старых" фреймов цепочки
function DUPLICATE_AND_CLEAR() {
//
// создаем копии текста всех фреймов цепочки
// и формируем массив ID
for(var i=0; i < STORY_LEN; i++){
	TF_ID[i] = TF[i].id;
	//
	// создаем копию текстового фрейма и снимаем textWrap на копии
	(TF_COPY[i] = TF[i].duplicate()).textWrapPreferences.textWrapType = 1852796517;
	//
	// ставим ignoreWrap на копии
	TF_COPY[i].textFramePreferences.ignoreWrap = true;
};// for i
//
// удаляем содержимое (текст) во всей цепочке
var end_char = CURRENT_STORY.characters.length - 1
var TEXT_TO_REMOVE = CURRENT_STORY.characters.itemByRange(0, end_char);
try { // подстраховка для обработки пустого фрейма
	TEXT_TO_REMOVE.remove();
} catch( error ) { };
//
// разрываем связи в "старых" фреймах
for(var i = STORY_LEN-1; i >= 0; i--){
	TF[i].nextTextFrame = null;
	TF[i] = app.activeDocument.textFrames.itemByID(TF_ID[i]);
}; // for i
//
// копируем содержимое из "копий" в "старые" фреймы
for(var i=0; i < STORY_LEN; i++){
	//
	// проверка переполнения фрейма
	var TF_OVERFLOW = TF_COPY[i].overflows;
	if( TF_OVERFLOW ) {// если есть переполнение
		do {
			var TEXT_COPY = TF_COPY[i].texts.anyItem();
			TEXT_COPY.move(LocationOptions.after, TF[i].texts.anyItem());
		} while( TF_COPY[i].characters.length > 0);
	}
	else {// если нет переполнения
		var TEXT_COPY = TF_COPY[i].texts.anyItem();
		TEXT_COPY.move(LocationOptions.after, TF[i].texts.anyItem());
	};// if-else
	//
	// удаляем временную копию фрейма
	TF_COPY[i].remove();
};// for i
return;
};// end DUPLICATE_AND_CLEAR
//
// подпрограмма создания новых связей в цепочке
function CONNECT(){
if( VAR == 1){// выделен 1 фрейм
	if(WHAT == 0) CONNECT_NON_SELECTED();// отделить только его
	if(WHAT == 1) { // разрыв справа от выделенного
		for(i= 0; i < i_SEL+1; i++) SELECTED[i] = false;
		for(i= i_SEL+1; i < STORY_LEN; i++) SELECTED[i] = true;
		CONNECT_SELECTED();
		CONNECT_NON_SELECTED();
	};// if
	if(WHAT == 2) {// разрыв слева от выделенного
		for(i= 0; i < i_SEL; i++) SELECTED[i] = false;
		for(i= i_SEL; i < STORY_LEN; i++) SELECTED[i] = true;
		CONNECT_NON_SELECTED();
		CONNECT_SELECTED();
	};// if
	if(WHAT == 3) the_exit(); // разделить все
};// if
if( VAR == 2) the_exit() // выделено 2 фрейма
if( VAR == 3){// выделено несколько фреймов
	if(WHAT == 0) {
		CONNECT_NON_SELECTED();
		if( CONNECT_AFTER ) CONNECT_SELECTED();
	};// if
	if(WHAT == 1) { // разделить все фреймы цепочки
		if( CONNECT_AFTER ) CONNECT_SELECTED();
	};// if
};// if
return;
};// end CONNECT
//
// подпрограмма связывания НЕ выделенных фреймов
function CONNECT_NON_SELECTED(){
	for(var i=0; i < STORY_LEN-1; i++){
		if(!SELECTED[i]) {
			var N = i;
			break;
		};// if
	};// for i
	for(var i = N; i < STORY_LEN-1; i++){
		if(!SELECTED[i]){
			for(var j= i+1; j < STORY_LEN; j++){
				if(!SELECTED[j]){
					TF[i].nextTextFrame = TF[j];
					break;
				};// if
			};// for j
		};// if
	};// for i
return
}
//
// подпрограмма связывания выделенных фреймов
function CONNECT_SELECTED(){
for(var i=0; i < STORY_LEN-1; i++){
	if(SELECTED[i]) {
		var N = i;
		break;
	};// if
};// for i
for(var i = N; i < STORY_LEN-1; i++){
	if(SELECTED[i]){
		for(var j= i+1; j < STORY_LEN; j++){
			if(SELECTED[j]){
				TF[i].nextTextFrame = TF[j];
				break;
			};// if
		};// for j
	};// if
};// for i
return;
};// end CONNECT_SELECTED
//
// ******** ПОДПРОГРАММА ОТОБРАЖЕНИЯ ДИАЛОГА
function DIALOG() {
//
// список фреймов для вывода
SEL_LIST = "";
for(var i=0; i < STORY_LEN; i++){
	if(SELECTED[i]){
		if( SEL_LIST == "" ) SEL_LIST = SEL_LIST + TF_NUMBER[i]
		else SEL_LIST = SEL_LIST + " " + TF_NUMBER[i];
		if(SEL_LEN == 1) {var N = i+1; i_SEL = i; break;};
		if(SEL_LEN > 1) SEL_LIST = SEL_LIST + "," ;
	};// if
};// for i
// удаляем последнюю запятую если только 1 фрейм выделен
if(SEL_LEN > 1) SEL_LIST = SEL_LIST.substr(0, SEL_LIST.length - 1);
// укорачиваем до 12 символов
SEL_LIST = SHORT_NAME(SEL_LIST, 12);
//
// собственно создание диалога
with(myDialog = app.dialogs.add({name:SCRIPT_TITLE+" "+SCRIPT_VERSION})){
	with(dialogColumns.add()){
		//
		// блок вывода информации о документе, выделенных фреймах и всей цепочке
		dialogRows.add().staticTexts.add({staticLabel:"Document: "+SHORT_NAME(AD.name, 20)});
		SAVE = checkboxControls.add({staticLabel:"Save document before operation", checkedState:false});
		dialogRows.add().staticTexts.add({staticLabel:"Text frames in the story (total):  "+STORY_LEN});
		dialogRows.add().staticTexts.add({staticLabel:"Number of selected text frames: "+SEL_LEN});
		dialogRows.add().staticTexts.add({staticLabel:"Selected text frame(s) position:  "+SEL_LIST});
		//
		// блок выбора вариантов
		var VAR_PAN = borderPanels.add();
		NO_VAR_3 = false;
		if( STORY_LEN > 2 &&
		    SEL_LEN == 1 &&
		    !SELECTED_START &&
		    !SELECTED_END) {
			VAR = 1;
			//
			// формируем строки для выбора вариантов
			var ST_1 = "[1..."+N+"] and ["+(N+1)+"..."+STORY_LEN+"]";
			if(N == STORY_LEN-1) var ST_1 = "[1..."+N+"]"+" and ["+(STORY_LEN)+"]";
			var ST_2 = "[1..."+(N-1)+"] and ["+(N)+"..."+STORY_LEN+"]";
			if(N == 2) var ST_2 = "[1] and ["+2+"..."+STORY_LEN+"]";
			with(VAR_PAN){
				with( WHAT = radiobuttonGroups.add()){
					radiobuttonControls.add({staticLabel:"Separate selected text frame only", checkedState:true});
					radiobuttonControls.add({staticLabel:"Make stories: " + ST_1});
					radiobuttonControls.add({staticLabel:"Make stories: " + ST_2});
					radiobuttonControls.add({staticLabel:"Separate all text frames in the story"});
				};// with WHAT
			};// with VAR_PAN
		NO_VAR_3 = true;
		};// if
		if( STORY_LEN == 2 ){
			VAR = 2;
			with(VAR_PAN){
				with( WHAT = radiobuttonGroups.add()){
					staticTexts.add({staticLabel:"Separate selected text frame(s)?"});
				};// with WHAT
			};// with VAR_PAN
			NO_VAR_3 = true;
		};// if
		if( STORY_LEN > 2 && !NO_VAR_3) {
			VAR = 3;
			with(VAR_PAN) {
				with(dialogColumns.add()) {
					with( WHAT = radiobuttonGroups.add()){
						radiobuttonControls.add({staticLabel:"Separate selected text frame(s) only", checkedState:true});
						radiobuttonControls.add({staticLabel:"Separate all text frames in the story"});
						if( SEL_LEN > 1 && SEL_LEN != STORY_LEN ) {
							var C_A = checkboxControls.add({staticLabel:"Connect separated text frames", checkedState:false});
						};//if
					};// with WHAT
				};// with dialogColumns
			};// with VAR_PAN
		};// if
	};// with dialogColumns
	myResult = myDialog.show(); // что нажато в диалоге - ОК или Cancel
	if(myResult == false){ // нажали Cancel в диалоге
		myDialog.destroy();
		the_exit();
	};// if
};// with myDialog
CONNECT_AFTER = false;
WHAT = WHAT.selectedButton;
SAVE = SAVE.checkedState;
if( SEL_LEN > 1 && SEL_LEN != STORY_LEN ) {
	CONNECT_AFTER = C_A.checkedState;
};// if
return;
};// end DIALOG
//
// ******** ПОДПРОГРАММА выполнения 
// 	    выбранной операции
function OPERATION(){
// сохраняем документ если требуется
var AD_SAVED = AD.saved;
var SAVED = false;
if( SAVE ) {
	try { 
		AD.save(); 
		 SAVED = true;
	} catch (error) { };// try-catch
	if(  SAVED && !AD_SAVED ) {
		CAN_TALK = false;
		CHECK_SELECTION();
	};// if
};// if
// открываем слои
if(NEED_OPEN_LAYERS) OPEN_LAYERS();
// собственно выполнение выбранных вариантов 
if(VAR == 1){
	DUPLICATE_AND_CLEAR();
	CONNECT();	
};// if
if(VAR == 2){
	SELECTED[0] = SELECTED[1] = true
	DUPLICATE_AND_CLEAR();
};// if
if(VAR == 3){
	if(WHAT == 0) {
		DUPLICATE_AND_CLEAR();
		CONNECT();
	};// if
	if(WHAT == 1 && CONNECT_AFTER) {
		if(!confirm("The story will be broken apart\n"+
			    "and connected again after that!\n"+
			    "Continue?")) the_exit();
	};// if
	if(WHAT == 1) {
		for(var i= 0; i < STORY_LEN; i++) SELECTED[i] = true;
		DUPLICATE_AND_CLEAR();
		CONNECT();
	};// if
};// if
// завершение работы скрипта
the_exit();
};// end OPERATION
//
// ******** ПОДПРОГРАММА назначения режима интерпретации скрипта (как в CS-CS2)
//
function SET_VERSION() {
	// если версия InDesign выше CS2
	// 3=CS; 4=CS2; 5=CS3; 6=CS4
	if( parseInt(app.version) > 4 ) app.scriptPreferences.version = 4;
return;
};// end SET_VERSION
//
// подпрограмма сохранения настроек
function SAVE_LAYERS_SETTINGS() {
	for( var i=0; i < AD.layers.length; i++ ) {
		AD_layers_vis[i] = AD.layers[i].visible;
		AD_layers_lock[i] = AD.layers[i].locked;
	};// for i
return;
}// end SAVE_LAYERS_SETTINGS
//
// подпрограмма восстановления настроек
function CLOSE_LAYERS() {
	for( var i=0; i < AD.layers.length; i++ ) {
		AD.layers[i].visible =AD_layers_vis[i];
		AD.layers[i].locked = AD_layers_lock[i];
	};// for i
return;
}// end CLOSE_LAYERS
//
// подпрограмма выхода
function the_exit() {
	if(LAYERS_WERE_OPEN) CLOSE_LAYERS();
	exit();
}//  end the_exit
//
// подпрограмма разблокирует и делает видимыми все слои
function OPEN_LAYERS() {
	for( var i=0; i < AD.layers.length; i++ ) {
		AD.layers[i].visible = true;
		AD.layers[i].locked = false;
	};// for i
	LAYERS_WERE_OPEN = true;
return;
}// end OPEN_LAYERS
//
// подпрограмма укорачивает имя док-та
function SHORT_NAME(txt, N) {
	if ( txt.length > N ) txt = txt.substr(0, N) + "...";
return txt;
};// end SHORT_NAME
//
//подпрограмма определения наличия TEXT PATH в цепочке
// и заодно определения необходимости открытия слоев
function TEXT_PATH_IN_STORY( the_story ) {
	var the_layer;
	var the_frame;
	for( var i=0; i < the_story.textFrames.length; i++ ) {
		 the_frame = the_story.textFrames[i];
		 if( TEXT_PATH_IN_FRAME( the_frame ) ) return true;
		the_layer = the_frame.itemLayer;
		if(the_layer.locked || !the_layer.visible) NEED_OPEN_LAYERS = true;
	};// for i
return false;
};// end TEXT_PATH_IN_STORY
//
// подпрограмма определения наличия TEXT PATH у фрейма в цепочке
function TEXT_PATH_IN_FRAME( the_frame ) {
		if( the_frame.parent.constructor.name == "GraphicLine" ) return true;
		if( the_frame.parent.constructor.name == "Oval" ) return true;
		if( the_frame.parent.constructor.name == "TextFrame" ) return true;
		if( the_frame.parent.constructor.name == "Rectangle" ) return true;
		if( the_frame.parent.constructor.name == "Polygon" ) return true;
return false;
};// end TEXT_PATH_IN_FRAME